// --------------
// Digital Button helper class
// -------------
class aBUTT {
  private:
    byte bpin;
    long ts = 0;
    bool previous_state = false;
    bool previous_state_holded = false;

  public:
    bool is_pressed = false;
    bool is_holded = false;

    bool on_pressed = false;
    bool on_released = false;
    bool on_holded = false;

    aBUTT(byte bpin) {
      this->bpin = bpin;
      init();
    }
    void init() {
      pinMode(bpin, INPUT);


    }


    void operateBUTTON() {

      is_pressed = digitalRead(bpin);


      on_pressed = false;
      on_released = false;

      if (previous_state != is_pressed) {

        if (is_pressed) {

          ts = millis();
          on_pressed = true;

        } else {

          on_released = true;
          is_holded = false;
          on_holded = false;
          previous_state_holded = on_holded;
        }

        previous_state = is_pressed;

      }

      on_holded = false;
      if (ts + 1000 < millis() && is_pressed ) {

        is_holded = true;


        if (previous_state_holded != is_holded && is_pressed ) {

          on_holded = true;
          previous_state_holded = is_holded;
          //Serial.println("holdi");
        }
      }
    }
};
