// ----------------------------------
// -------- MAIN LOOP  --------
// ----------------------------------
  
 
aLED led1(11);
aBUTT button1(12);

bool is_recording = false;
long recording_base_ts = 0;

long playhead_ts = 0;
int nextPos = 0; //playhead var
int postick= 0;
 

void setup() {
   
   Serial.begin(9600);
}
  
void loop() {
   
  led1.operateLED(); //operate specific LED
  button1.operateBUTTON();

 
  // QUIT RECORDING MODE
  if(button1.on_holded && is_recording ){

        Serial.print("DONE RECORDING");
        is_recording = false;
        led1.setMode(0);
        led1.brightness = 66;


        Serial.print("TRY PLAYBACK MODE");
        playhead_ts = millis();
        nextPos = recording_arr[0];// set first pulse target   
        postick = 0;    
        return;
   
  }




  // INIT RECORDING MODE
  if(button1.on_holded && is_recording==false){

      list_end = 0;
      Serial.print("RECORDING");
      led1.setMode(0);
      led1.brightness = 255;
      is_recording = true;
      recording_base_ts = millis(); // set the base timestamp of the recording
           
  }


  if(!is_recording && list_end > 0){
    
    // have a recording - so play through!

      // Serial.print(".");
      int playposition = millis()-playhead_ts;

        
      if( playposition > nextPos){

          toggleLED();
           //Serial.println(nextPos);
          postick++;

          if(postick>=list_end){ // reset playhead when reached end of play Array!
            playhead_ts = millis();
            postick=0;
            
            }
          nextPos = recording_arr[postick];
       } 

     
    
       
    
   } 

  

  if(is_recording){

      if(button1.on_pressed){

          long ctsabs = millis() - recording_base_ts;
          //Serial.print( ctsabs);
          //Serial.print( "  >__ > " );
          push(ctsabs);
          led1.brightness=33;
          
      }

      if(button1.on_released){

          long ctsabs = millis() - recording_base_ts;
          //Serial.println( ctsabs);
           push(ctsabs);
          led1.brightness=200;
      }
    
   }

     // led1.operateLED(); //operate specific LED
   delay(10);
}


void toggleLED(){
  led1.setMode(0);
  if(led1.brightness==255 ){
     
  led1.brightness=0; }else{
    led1.brightness=255;
    }
  //Serial.println();
 }
